build "go_build" "linux" {
    for_each = local.linux_archs

    binary = "buildr_linux_${each.key}"
    main   = "."
    goos   = "linux"
    goarch = each.key

    flags = [
        "-v",
        "-trimpath",
        "-a",
        "-installsuffix=cgo"
    ]

    ldflags = [
        "-w -s",
        "-X 'code.icb4dc0.de/buildr/buildr/cmd.CurrentVersion=${vcs.tag == "" ? local.default_version : vcs.tag}'"
    ]

    environment = {
        CGO_ENABLED = "0"
    }

    depends_on = [
        tasks.go_generate.id
    ]
}

build "go_build" "darwin" {
    for_each = local.macos_archs

    binary = "buildr_darwin_${each.key}"
    main   = "."
    goos   = "darwin"
    goarch = each.key

    flags = [
        "-v",
        "-trimpath",
        "-a",
        "-installsuffix=cgo"
    ]

    ldflags = [
        "-w -s",
        "-X 'code.icb4dc0.de/buildr/buildr/cmd.CurrentVersion=${vcs.tag == "" ? local.default_version : vcs.tag}'"
    ]

    environment = {
        CGO_ENABLED = "0"
    }

    depends_on = [
        tasks.go_generate.id
    ]
}