package "gzip_file" "buildr_linux" {
    for_each = local.linux_archs

    src = "buildr_linux_${each.key}"

    input_mapping = {
        "${builds.linux[each.key].out_dir}" = "."
    }

    depends_on = [
        builds.linux[each.key].id
    ]
}

package "gzip_file" "buildr_darwin" {
    for_each = local.macos_archs

    src = "buildr_darwin_${each.key}"

    input_mapping = {
        "${builds.darwin[each.key].out_dir}" = "."
    }

    depends_on = [
        builds.darwin[each.key].id
    ]
}


package "container_image" "buildr_image" {
  base_image = "gcr.io/distroless/static"
  image_name = "code.icb4dc0.de/buildr/buildr"
  platform   = "linux/amd64"

  entrypoint = [
    "/usr/local/bin/buildr"
  ]

  tags = [
    "latest"
  ]

  publish_to_daemon   = true
  publish_to_registry = true

  registry_auth "code.icb4dc0.de" {
    auth = base64encode(format("prskr:%s", from_vault("gitea_token")))
  }

  input_mapping = {
    "${repo.root}"                     = "."
    "${builds.linux["amd64"].out_dir}" = "out/"
  }

  content = {
    "out/buildr" = "/usr/local/bin/buildr",
    "README.md"  = "/usr/local/man/README.md"
  }

  depends_on = [
    builds.linux["amd64"].id
  ]
}