locals {
    tool_versions {
        mockery       = gh_latest_release("vektra", "mockery", from_vault("github_token"))
        gotestsum     = gh_latest_release("gotestyourself", "gotestsum", from_vault("github_token"))
        golangci_lint = gh_latest_release("golangci", "golangci-lint", from_vault("github_token"))
    }
}

tool "go_tool" "mockery" {
    binary_name = "mockery"
    repository  = "github.com/vektra/mockery/v2"
    version     = local.tool_versions.mockery
    build_args  = [
        "-v",
        "-trimpath",
        "-a",
        "-installsuffix=cgo"
    ]

    environment = {
        CGO_ENABLED = "0"
    }
}

tool "go_tool" "gotestsum" {
    binary_name = "gotestsum"
    repository  = "gotest.tools/gotestsum"
    version     = local.tool_versions.gotestsum
    build_args  = [
        "-v",
        "-trimpath",
        "-a",
        "-installsuffix=cgo"
    ]
    environment = {
        CGO_ENABLED = "0"
    }
}
