package archive

import (
	"errors"
	"io"

	"github.com/klauspost/compress/s2"
)

func WriteTarS2Encoded(tar Tar, writer io.Writer) (err error) {
	s2Writer := s2.NewWriter(writer)
	defer func() {
		err = errors.Join(err, s2Writer.Close())
	}()

	return tar.Write(s2Writer)
}
