package rpc

import "flag"

type GrpcConfig struct {
	Host struct {
		Address string `mapstructure:"grpc-serve-address"`
	} `mapstructure:",squash"`
}

func (c *GrpcConfig) Flags() *flag.FlagSet {
	fs := flag.NewFlagSet("grpc", flag.ExitOnError)

	fs.StringVar(
		&c.Host.Address,
		"grpc-serve-address",
		":3000",
		"Address on which the gRPC server will listen",
	)

	return fs
}
