package vault

import "errors"

var (
	ErrNoEncryption            = errors.New("no encryption")
	_               Encryption = (*errEncryption)(nil)
)

type errEncryption struct{}

func (errEncryption) Encrypt([]byte, []byte) (cipherText, salt, nonce []byte, err error) {
	return nil, nil, nil, ErrNoEncryption
}

func (errEncryption) Decrypt([]byte, []byte, []byte, []byte) (plainText []byte, err error) {
	return nil, ErrNoEncryption
}
