package vault

import (
	"os"
)

func WithPassphrase(passphrase string) InitOption {
	return initOptionFunc(func(vault *Vault) error {
		vault.passphrase = []byte(passphrase)
		return nil
	})
}

func WithPassphraseFile(path string) InitOption {
	return initOptionFunc(func(vault *Vault) error {
		passphraseBytes, err := os.ReadFile(path)
		if err != nil {
			return err
		}

		vault.passphrase = passphraseBytes
		return nil
	})
}

func WithEncryption(encryption Encryption) InitOption {
	return initOptionFunc(func(vault *Vault) error {
		vault.encryption = encryption
		return nil
	})
}
