package archive

import (
	"context"

	"code.icb4dc0.de/buildr/buildr/modules"
)

func (b GzipFileCompression) Help(context.Context) (help modules.Help, err error) {
	help = modules.Help{
		Name:        b.Type(),
		Description: "Compress a file using gzip",
		Examples: []modules.Example{
			{
				Name:        "Basic example",
				Description: "Create a gzipped file without specifying an output file.",
				Spec: &modules.Metadata[GzipFileCompression]{
					Module: GzipFileCompression{
						Source: "buildr_linux_amd64",
					},
					ModuleName: "linux_amd64_gzip",
				},
			},
		},
	}

	return help, nil
}
