package archive

import (
	"context"

	"code.icb4dc0.de/buildr/buildr/modules"
)

func (t TarArchive) Help(context.Context) (help modules.Help, err error) {
	help = modules.Help{
		Name: t.Type(),
		Description: `This module helps to create - optionally compressed - tar archives.
If there's no explicit ` + "`content`" + ` field, all files in the working directory will be added to the archive.`,
		Examples: []modules.Example{
			{
				Name:        "Basic example",
				Description: `This very basic example explains how to make use of the module.`,
				Spec: &modules.Metadata[TarArchive]{
					ModuleName: "buildr_linux_release",
					Module: TarArchive{
						Name:        "buildr_linux.tar.gz",
						Compression: CompressionGzip,
					},
				},
			},
		},
	}

	return help, nil
}
