package archive

import (
	"context"

	"code.icb4dc0.de/buildr/buildr/modules"
)

func (z ZipArchive) Help(context.Context) (help modules.Help, err error) {
	help = modules.Help{
		Name: z.Type(),
		Description: `This module helps to create zip archives.
If there's no explicit ` + "`content`" + ` field, all files in the working directory will be added to the archive.
Optionally you can wrap the archive in a directory with the ` + "`wrap_in_directory`" + `setting introducing a common prefix.`,
		Examples: []modules.Example{
			{
				Name:        "Basic example",
				Description: `This very basic example explains how to make use of the module.`,
				Spec: &modules.Metadata[ZipArchive]{
					ModuleName: "buildr_windows_release",
					Module: ZipArchive{
						Name: "buildr_win.zip",
					},
				},
			},
		},
	}

	return help, nil
}
