package ociimg

import (
	"context"

	"github.com/google/go-containerregistry/pkg/name"
	v1 "github.com/google/go-containerregistry/pkg/v1"
	"github.com/google/go-containerregistry/pkg/v1/types"
)

const (
	latestTag = "latest"
	userAgent = "buildr"
)

type imageOrIndex interface {
	RawManifest() ([]byte, error)
	MediaType() (types.MediaType, error)
	Digest() (v1.Hash, error)
}

type Publisher interface {
	Publish(ctx context.Context, result imageOrIndex) (name.Reference, error)
}
