package packaging

import (
	"code.icb4dc0.de/buildr/buildr/modules"
	"code.icb4dc0.de/buildr/buildr/modules/packaging/archive"
	"code.icb4dc0.de/buildr/buildr/modules/packaging/ociimg"
)

var Registration = modules.RegistrationFunc(func(registry *modules.TypeRegistry) {
	registry.RegisterModule(modules.ModuleFactoryFunc(func() modules.ModuleWithMeta {
		return new(modules.Metadata[ociimg.ContainerImage])
	}))

	registry.RegisterModule(modules.ModuleFactoryFunc(func() modules.ModuleWithMeta {
		return new(modules.Metadata[archive.ZipArchive])
	}))

	registry.RegisterModule(modules.ModuleFactoryFunc(func() modules.ModuleWithMeta {
		return new(modules.Metadata[archive.TarArchive])
	}))

	registry.RegisterModule(modules.ModuleFactoryFunc(func() modules.ModuleWithMeta {
		return new(modules.Metadata[archive.GzipFileCompression])
	}))
})
