package vcs

type GitCommitAuthor struct {
	Name  string `cty:"name"`
	Email string `cty:"email"`
}

type GitCommit struct {
	Hash    string          `cty:"commit_hash"`
	Author  GitCommitAuthor `cty:"author"`
	Message string          `cty:"message"`
}

type Git struct {
	Commit         GitCommit `cty:"commit"`
	Branch         string    `cty:"branch"`
	Tag            string    `cty:"tag"`
	Reference      string    `cty:"reference"`
	StagedFiles    []string  `cty:"staged_files"`
	UnstagedFiles  []string  `cty:"unstaged_files"`
	ModifiedFiles  []string  `cty:"modified_files"`
	UntrackedFiles []string  `cty:"untracked_files"`
	Dirty          bool      `cty:"dirty"`
}
